#include <err.h>
#include <stdio.h>

#include <abac.h>

#include "options.h"

int main(int argc, char **argv) {
    int i, success;
    abac_credential_t *cred;

    options_t opts = { 0, };
    get_options(argc, argv, &opts);

    libabac_init();

    abac_context_t *ctx = abac_context_new();
    abac_context_load_directory(ctx, opts.keystore);

    abac_credential_t **credentials = abac_context_query(ctx,
        opts.role, opts.principal,
        &success
    );

    if (success)
        puts("success");

    if (credentials != NULL)
        for (i = 0; credentials[i] != NULL; ++i) {
            cred = credentials[i];
            abac_role_t *tail = abac_credential_tail(cred);
            printf("credential %s <- %s\n",
                    abac_role_string(abac_credential_head(cred)),
                    tail != NULL ? abac_role_string(tail) : "(null)"
                  );
        }

    abac_context_credentials_free(credentials);

    abac_context_free(ctx);

    libabac_deinit();

    return 0;
}
